#include <unistd.h> 
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/ioctl.h> 

#include "dmabuf.h"

int main(int argc, char *argv[])
{
  int i, fd0, fd1, err, size;
  char *dmabuf;
  unsigned long phy_addr;

  fd0 = open("/dev/dmabuf0", O_RDWR);
  if(fd0 < 0) {
    perror("open");
    return -1;
  }

  err = ioctl(fd0, DMABUF_GET_SIZE, &size);
  if(err < 0)
    perror("ioctl");
  printf("DMA buffer size: %d\n", size);

  err = ioctl(fd0, DMABUF_GET_PHY_ADDR, &phy_addr);
  if(err < 0)
    perror("ioctl");
  printf("DMA buffer physical address: %lx\n", phy_addr);

  dmabuf = (char *)mmap(0, size, PROT_READ | PROT_WRITE, MAP_SHARED, fd0, 0);
  if((int)dmabuf < 0) {
    perror("mmap");
    return -1;
  }

  printf("DMA buffer logical address: %p\n", dmabuf);
  printf("DMA buffer contents: %s\n", dmabuf);

  for(i = 0; i < size; i++)
    dmabuf[i] = (char)i;

  for(i = 0; (i < size) && (dmabuf[i] == (char)i); i++);
  if(i != size)
    fprintf(stderr, "Error: buffer data integrity no preserved!\n");

  strcpy(dmabuf, "dmabuf test OK!");
  printf("DMA buffer contents: %s\n", dmabuf);

  fd1 = open("/dev/dmabuf1", O_RDWR);
  if(fd1 < 0) {
    perror("open");
    return -1;
  }

  err = ioctl(fd1, DMABUF_GET_SIZE, &size);
  if(err < 0)
    perror("ioctl");
  printf("DMA buffer size: %d\n", size);

  err = ioctl(fd1, DMABUF_GET_PHY_ADDR, &phy_addr);
  if(err < 0)
    perror("ioctl");
  printf("DMA buffer physical address: %lx\n", phy_addr);

  dmabuf = (char *)mmap(0, size, PROT_READ | PROT_WRITE, MAP_SHARED, fd1, 0);
  if((int)dmabuf < 0) {
    perror("mmap");
    return -1;
  }

  printf("DMA buffer logical address: %p\n", dmabuf);
  printf("DMA buffer contents: %s\n", dmabuf);

  for(i = 0; i < size; i++)
    dmabuf[i] = (char)i;

  for(i = 0; (i < size) && (dmabuf[i] == (char)i); i++);
  if(i != size)
    fprintf(stderr, "Error: buffer data integrity no preserved!\n");

  strcpy(dmabuf, "dmabuf test OK!");
  printf("DMA buffer contents: %s\n", dmabuf);

  close(fd0);
  close(fd1);
  return 0;
}
